IOCTL(2)

NAME
ioctl - control device

SYNOPSIS
#include <sys/ioctl.h>
int
ioctl(int d, unsigned long request, ...);

DESCRIPTION
The ioctl() function manipulates the underlying device parameters of special files. In particular, many operating characteristics of character special files (e.g., terminals) may be controlled with ioctl() requests.

The argument d must be an open file descriptor. The third argument is called arg and contains additional information needed by this device to perform the requested function. arg is either an int or a pointer to a device-specific data structure, depending upon the given request.

An ioctl request has encoded in it whether the argument is an “in” parameter or “out” parameter, and the size of the third argument (arg) in bytes. Macros and defines used in specifying an ioctl request are located in the file <sys/ioctl.h>.

RETURN VALUES
If an error has occurred, a value of -1 is returned and errno is set to indicate the error.

ERRORS
ioctl() will fail if:

[EBADF]
    d is not a valid descriptor.

[ENOTTY]
    d is not associated with a character special device.

[ENOTTY]
    The specified request does not apply to the kind of object that the descriptor d references.

[EINVAL]
    request or arg is not valid.

[EFAULT]
    arg points outside the process's allocated address space.

SEE ALSO
cdio(1), chio(1), mt(1), execve(2), fcntl(2), intro(4), tty(4)

HISTORY
An ioctl() function call appeared in AT&T UNIX.